#include <iostream>
#include <fstream>
#include <string.h>
using namespace std;

const int MAXN = 20;
const int DIMR = 8;
const int DIMC = 8;

enum Colore {Bianco, Nero};
enum Operatore {And, Or};

struct Immagine{
  char nome[MAXN];
  Colore pix[DIMR][DIMC];
};

void ribalta(Immagine* pimm);
bool carica(Immagine* pimm, const char nf[]);
void stampa(const Immagine* pimm);
void modifica(Immagine* pim1, const Immagine* pim2, Operatore o);
int quanti(const Immagine* pimm, int x, int y, Colore c);

void menu(){
  cout << "0) esci" << endl;
  cout << "1) carica" << endl;
  cout << "2) stampa" << endl;
  cout << "3) ribalta" << endl;
  cout << "4) modifica" << endl;
  cout << "5) quanti" << endl;
}

int main(){
  const int MAXS = 100;
  Immagine im1, im2;
  char c;
  char file[MAXS];
  bool res;
  int q, x, y;
  Colore col;
  Operatore op;
  while(true) {
    menu();
    cin >> c;
    switch(c) {
      case '1':
        cout << "Inserisci il nome del file: ";
        cin >> file;
        res = carica(&im1, file); 
        if(res) cout << "Caricamento ok" << endl;
        else cout << "Errore in caricamento" << endl;
        break;
      case '2':
        stampa(&im1);
        break;
      case '3':
        ribalta(&im1);
        break;
      case '4':
        cout << "Inserisci il nome del file (per im2): ";
        cin >> file;
        res = carica(&im2, file); 
        if(res) cout << "Caricamento ok" << endl;
        else {
          cout << "Errore in caricamento" << endl;
          break;
        }
        cout << "Inserisci operatore (A=and, O=or): ";
        cin >> c;
        op = c == 'A' ? And : Or;
        cout << "Modifico im1" << endl;
        modifica(&im1, &im2, op);
        break; 
      case '5':
        cout << "Inserisci x: ";
        cin >> x;
        cout << "Inserisci y: ";
        cin >> y;
        cout << "Inserisci colore (B=bianco, N=nero): ";
        cin >> c;
        col = c == 'N' ? Nero : Bianco;
        q = quanti(&im1, x, y, col);
        cout << q << endl;
        break;
      case '0':
        return 0;
      default:
        cout << "Scelta inesistente" << endl;
    }
  }
}
