#include <iostream>
#include <fstream>
#include <string.h>
using namespace std;

const int MAXN = 20;
const int DIMR = 8;
const int DIMC = 8;

enum Colore {Bianco, Nero};
enum Operatore {And, Or};

struct Immagine{
  char nome[MAXN];
  Colore pix[DIMR][DIMC];
};

void ribalta(Immagine* pimm) {
  Colore tmp;
  for(int i=0; i<DIMR; i++) {
    for(int j=0; j<DIMC/2; j++) {
      tmp = pimm->pix[i][j];
      pimm->pix[i][j] = pimm->pix[i][DIMC-1-j];
      pimm->pix[i][DIMC-1-j] = tmp;
    }
  }
}

bool carica(Immagine* pimm, const char nf[]) {
  Colore c;
  char car;
  fstream ff;
  ff.open(nf, ios::in);
  if(!ff) return false;
  for(int i=0; i<DIMR; i++) {
    for(int j=0; j<DIMC; j++) {
      ff >> car;
      switch(car) {
        case 'n': case 'N':
          c = Nero;
          break;
        case 'b': case 'B':
          c = Bianco;
          break;
        default:
          return false;
      }
      pimm->pix[i][j] = c;
    }
  }
  strcpy(pimm->nome, nf);
  return true;
}

char f(Colore c) {
  switch(c) {
    case Nero:
      return ' ';
    case Bianco:
      return 'X';
  }
}

void stampa(const Immagine* pimm) {
  cout << pimm->nome << endl;
  for(int i=0; i<DIMR; i++) {
    for(int j=0; j<DIMC; j++)
      cout << f(pimm->pix[i][j]);
    cout << endl;
  }
}

Colore funand(Colore a, Colore b) {
  if(a == Bianco && b == Bianco) return Bianco;
  return Nero;
}

Colore funor(Colore a, Colore b) {
  if(a == Bianco || b == Bianco) return Bianco;
  return Nero;
}

void modifica(Immagine* pim1, const Immagine* pim2, Operatore o) {
  for(int i=0; i<DIMR; i++) {
    for(int j=0; j<DIMC; j++) {
      if(o == And)
        pim1->pix[i][j] = funand(pim1->pix[i][j], pim2->pix[i][j]);     
      else  
        pim1->pix[i][j] = funor(pim1->pix[i][j], pim2->pix[i][j]);     
    }
  }
}

int quanti(const Immagine* pimm, int x, int y, Colore c) {
  int cont = 0;
  int startr = y == 0 ? y : y - 1;
  int endr = y == DIMR - 1 ? DIMR - 1 : y + 1;
  int startc = x == 0 ? x : x - 1;
  int endc = c == DIMC - 1 ? DIMC - 1 : x + 1;
  for(int i=startr; i<=endr; i++)
    for(int j=startc; j<=endc; j++) 
      cont += pimm->pix[i][j]==c ? 1 : 0;
  return cont;
}

